- name: Lookups Gerrit Slaves StatefulSet
  async: 30
  changed_when: False
  failed_when: False
  k8s_info:
    api_version: "{{ sts_apivers }}"
    kind: StatefulSet
    namespace: "{{ namespace }}"
    name: "{{ gerrit_name }}-slave"
  no_log: True
  poll: 5
  register: has_sts
- name: Purges StatefulSet if required
  async: 30
  k8s:
    definition: "{{ lookup('template', 'gerrit-slave.j2') }}"
    state: absent
  poll: 5
  when:
  - has_sts is defined
  - has_sts.resources is defined
  - has_sts.resources[0] is defined
  - has_sts.resources[0].spec is defined
  - has_sts.resources[0].spec.podManagementPolicy is defined
  - >
      has_sts.resources[0].spec.podManagementPolicy != 'Parallel'
      or (gerrit_replicas | int) == 1
- name: Installs Gerrit Slaves StatefulSet
  async: 30
  k8s:
    definition: "{{ lookup('template', 'gerrit-slave.j2') }}"
  poll: 5
  when:
  - (gerrit_replicas | int) > 1
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 8080
    - 29418
    - 29419
    svc_name: "{{ gerrit_name }}-slave"
    svc_state: "{{ 'present' if ((gerrit_replicas | int) > 1)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ gerrit_name }}"
    policy_name: "{{ gerrit_name }}-to-{{ gerrit_name }}-slaves"
    policy_state: "{{ 'present' if (do_network_policy
                                    and (gerrit_replicas | int) > 1)
                                else 'absent' }}"
    subject: "{{ gerrit_name }}-slave"
    to:
    - number: "8080"
    - number: "29418"
    - number: "29419"
- include_role:
    name: commons
    tasks_from: helpers/route.yaml
  vars:
    route_host: "{{ gerritslave_fqdn }}"
    route_name: "{{ gerrit_name }}-slave"
    route_state: "{{ 'present' if ((gerrit_replicas | int) > 1)
                               else 'absent' }}"
    svc_name: "{{ gerrit_name }}-slave"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ gerrit_name }}-slaves"
    policy_state: "{{ 'present' if (do_network_policy
                                    and (gerrit_replicas | int) > 1)
                                else 'absent' }}"
    subject: "{{ gerrit_name }}-slave"
    to:
    - number: "8080"
